#!/usr/bin/python3
# -*- coding: utf-8 -*-
import matplotlib.pyplot as plt
import numpy as np
import os,time
import scipy.io.wavfile as wavf
from scipy import *
from scipy import stats
from scipy.signal import *
from threading import Thread
import threading



fig, ax = plt.subplots(3,1)

def entrer_distance(j):
	print('Entrer la valeur',j,'en mètre de la distance séparant les deux micros:')
	distance=float(input())
	return distance
	
def enregistre(duree):
	def record():
		os.system('ffmpeg -nostats -loglevel 0 -f alsa -i hw:0 -t {} -ar 44100 bip2.wav -y'.format(duree))
	tenregistre=threading.Thread(target=record)
	tenregistre.start()

def lecture(x):
	def read():
		time.sleep(0)
		os.system('cvlc --no-loop {}'.format(x))
	tlecture=threading.Thread(target=read)
	tlecture.start()

def traitement_gauche():
	time.sleep(3)
	os.system('ffmpeg -nostats -loglevel 0 -i bip2.wav -map_channel 0.0.0 left.wav -map_channel 0.0.1 right.wav -y')
	Fe, data_left = wavf.read('left.wav')
	global Te
	Te=1.0/Fe


	moyL=sum(data_left)/len(data_left)
	dataL=data_left-moyL
	global m_hatL
	m_hatL = abs(dataL)
	#print('moyL=',sum(m_hatL)/len(m_hatL))
	i=0
	while(m_hatL[i]<sum(m_hatL)/len(m_hatL)):
		global indexL
		indexL=i
		i=i+1
	tL=indexL*Te


	return tL
	
def traitement_droit():
	Fe, data_right = wavf.read('right.wav')
	
	moyR=sum(data_right)/len(data_right)
	dataR=data_right-moyR
	global m_hatR
	m_hatR = abs(dataR)
	#print('moyR=',sum(m_hatR)/len(m_hatR))
	i=0
	while(m_hatR[i]<sum(m_hatR)/len(m_hatR)):
		indexR=i
		i=i+1
	
	tR=indexR*Te
	
	return tR


	
def plot(a,b):
	t=np.arange(0,len(m_hatL)*Te,Te)
	ax[0].clear()
	ax[1].clear()
	ax[2].clear()
	ax[0].plot(t,m_hatL,'g')
	ax[0].set_xlim(indexL*Te-100*Te,indexL*Te+300*Te)
	ax[0].set_xlabel('Temps(s)')
	ax[1].plot(t,m_hatR,'r')
	ax[1].set_xlim(indexL*Te-100*Te,indexL*Te+300*Te)
	ax[1].set_xlabel('Temps(s)')

	ax[2].plot(a,b,'bo')
	slope,intercept, r_value, p_value, std_err = stats.linregress(a, b)
	fit=[]
	for z in a:
		fit.append(slope*z)
	print('pente', slope)
	print('fit', fit)
	ax[2].plot(a, intercept+fit, 'r', label=u'modele')
	ax[2].text(0,0,'pente={} m/s'.format(round(slope,1)))
	ax[2].set_ylim(0,1)
	ax[2].set_xlim(0,0.005)
	ax[2].set_xlabel('Retard(s)')
	ax[2].set_ylabel('distance(m)')
	plt.show(block=False)


	


